//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PfExcel.h"
#include "PfOOCalc.h"
#include "ExcelReadUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
OleVariant dummyArray()
{
	return VarArrayCreate(OPENARRAY(int, (0, -1)), varVariant);
}
//---------------------------------------------------------------------------
String ConvertToURL(const String &path)
{
	String rtn = "file:";
	String svv = ExpandUNCFileName(path);
	if (svv.Length() > 0 && svv[1] != '\\')
		rtn += String("///");
	for (int i = 1; i <= svv.Length(); i++) {
#if __BORLANDC__ < 0x600
		if (svv.IsLeadByte(i)) {
			rtn += svv.SubString(i, 2);
			i++;
			continue;
		}
#endif
        switch (svv[i]) {
			case '\\': rtn += String('/'); break;
			case '%':  rtn += String("%25"); break;
			case ' ':  rtn += String("%20"); break;
			default: rtn += String(svv[i]);
		}
	}
	return rtn;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FileBtnClick(TObject *Sender)
{
	if (OpenDialog1->Execute()) {
        Edit1->Text = OpenDialog1->FileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	// GNZ̓eStringGrid1ɕ\
	StringGrid1->ColCount = 5;
	StringGrid1->RowCount = 5;
	for (int i = 0; i < 5; i++)
		StringGrid1->Rows[i]->CommaText = ",,,,";

	DWORD dw0 = ::GetTickCount();
	Variant objExcel, workbook, worksheet, row, range;
	int errcnt = 0;
	try {
		objExcel = Variant::CreateObject("Excel.Application");
		// Excel\
		objExcel.OlePropertySet("Visible", false);
		// x⃁bZ[W\Ȃ
		objExcel.OlePropertySet("DisplayAlerts", false);
		// t@Cǂ
		workbook = objExcel.OlePropertyGet("WorkBooks").
					OleFunction("Open", (OleVariant)Edit1->Text); // OK
					//OleFunction("Open", (Variant)Edit1->Text); // NG
		//ANeBuV[g
		worksheet = workbook.OlePropertyGet("ActiveSheet");
		//gpĂ͈
		range = worksheet.OlePropertyGet("UsedRange");
	}
	catch (Exception &e) {
		RichEdit1->Lines->Add(e.Message);
		errcnt++;
	}
	if (errcnt == 0) {
		Variant var_array;
		TStringList *list = new TStringList;
		try {
			int ncols = range.OlePropertyGet("Columns").OlePropertyGet("Count");
			int nrows = range.OlePropertyGet("Rows").OlePropertyGet("Count");
			for (int irow = 1; irow <= nrows; irow++) {
				row = range.OlePropertyGet("Rows", irow);
				var_array = row.OlePropertyGet("Value2");
				// s2z񂪕Ԃ
				int n = var_array.ArrayDimCount();
				if (n >= 2) {
					int l1 = var_array.ArrayLowBound(1);
					//int h1 = var_array.ArrayHighBound(1);
					int l2 = var_array.ArrayLowBound(2);
					int h2 = var_array.ArrayHighBound(2);
					if (h2 > ncols)
						h2 = ncols;
					list->Clear();
					// s̐擪͍sԍ
					list->Insert(0, String(irow));
					for (int i = l2; i <= h2; i++)
						list->Add(var_array.GetElement(l1, i));
					if (StringGrid1->ColCount < list->Count)
						StringGrid1->ColCount = list->Count;
					StringGrid1->RowCount = StringGrid1->FixedRows + irow;
					StringGrid1->Rows[irow]->Assign(list);
				}
			}
		}
		catch (Exception &e) {
			RichEdit1->Lines->Add(e.Message);
			errcnt++;
		}
		objExcel.OleProcedure("Quit");

		// StringGridɃJo A,B,... t
		list->Clear();
		list->Add("");
		for (int i = StringGrid1->FixedCols; i < StringGrid1->ColCount; i++) {
			int icol = i - StringGrid1->FixedCols;
			String scol = (char)('A' + (icol % 26));
			int cx = icol / 26;
			while (cx > 0) {
				cx--;
				scol = String((char)('A' + (cx % 26))) + scol;
				cx = cx / 26;
			}
			list->Add(scol);
		}
		StringGrid1->Rows[0]->Assign(list);
		delete list;
	}
	objExcel = Unassigned;
	workbook = Unassigned;
	worksheet = Unassigned;
	range = Unassigned;

	DWORD dw9 = ::GetTickCount();
	RichEdit1->Lines->Add(String("oߎ = ") + (dw9 - dw0));
	RichEdit1->Perform(EM_SCROLL, SB_LINEDOWN, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	StringGrid1->ColCount = 5;
	StringGrid1->RowCount = 5;
	for (int i = 0; i < 5; i++)
		StringGrid1->Rows[i]->CommaText = ",,,,";

	DWORD dw0 = ::GetTickCount();

	// OpenOffice (or LibreOffice) Ńt@Cǂ
	Variant vOpenOffice; //T[rX}l[W
	Variant vStarDesktop; //T[rX
	Variant vDocument; //hLg
	TStringList *list = new TStringList;

	try {
		//T[rX}l[W
		vOpenOffice = Variant::CreateObject("com.sun.star.ServiceManager");
		//T[rX
		vStarDesktop = vOpenOffice.OleFunction(
								"createInstance",
								(OleVariant)"com.sun.star.frame.Desktop");
		// t@Cǂ
		// ǂݍݎ̃IvVwŔ\AReadOnlyɂ
		Variant props = VarArrayCreate(OPENARRAY(int, (0, 1)), varVariant);
		Variant prop = vOpenOffice.OleFunction(
						"Bridge_GetStruct",
						(OleVariant)"com.sun.star.beans.PropertyValue");
		// \
		prop.OlePropertySet("Name", (OleVariant)"Hidden");
		prop.OlePropertySet("Value", true);
		props.PutElement(prop, 0);
		prop = vOpenOffice.OleFunction(
						"Bridge_GetStruct",
						(OleVariant)"com.sun.star.beans.PropertyValue");
		// ReadOnly
		prop.OlePropertySet("Name", (OleVariant)"ReadOnly");
		prop.OlePropertySet("Value", true);
		props.PutElement(prop, 1);
		vDocument = vStarDesktop.OleFunction(
						"loadComponentFromURL",
						(OleVariant)ConvertToURL(Edit1->Text),
						(OleVariant)"_blank",
						(OleVariant)0,
						props);
#if 0
		// VK쐬̏ꍇ
		vDocument = vStarDesktop.OleFunction(
						"loadComponentFromURL",
						(OleVariant)"private:factory/scalc",
						(OleVariant)"_blank",
						(OleVariant)0,
						dummyArray());
#endif
		Variant sheet, range, cell, addr, cursor;
		Variant varray;

		// 擪́iOԖځjV[g
		sheet = vDocument.OleFunction("getSheets").OleFunction("getByIndex", 0);

		// gp͈͂J[\ŋ߂
		cursor = sheet.OleFunction("createCursor");
		// J[\gp͈͂̐擪Ɉړ
		cursor.OleProcedure("gotoStartOfUsedArea", false);
		cell = cursor.OleFunction("getCellByPosition", 0, 0);
		addr = cell.OlePropertyGet("CellAddress");
		int c0 = addr.OlePropertyGet("Column");
		int r0 = addr.OlePropertyGet("Row");
		// J[\gp͈͂̍ŌɈړ
		cursor.OleProcedure("gotoEndOfUsedArea", false);
		cell = cursor.OleFunction("getCellByPosition", 0, 0);
		addr = cell.OlePropertyGet("CellAddress");
		int c1 = addr.OlePropertyGet("Column");
		int r1 = addr.OlePropertyGet("Row");

		RichEdit1->Lines->Add(String("c0 = ") + c0 + "; r0 = " + r0);
		RichEdit1->Lines->Add(String("c1 = ") + c1 + "; r1 = " + r1);
		RichEdit1->Perform(EM_SCROLL, SB_LINEDOWN, 0);

		int isgrow = StringGrid1->FixedRows;
		for (int irow = r0; irow <= r1; irow++, isgrow++) {
			int idx0, idx1;
			// gp͈͂̂Ps
			range = sheet.OleFunction("getCellRangeByPosition", c0, irow, c1, irow);
			varray = range.OleFunction("getDataArray");
			// varraýAz̔zɂȂĂ
			idx0 = varray.ArrayLowBound(1);
			varray = varray.GetElement(idx0);
			idx0 = varray.ArrayLowBound(1);
			idx1 = varray.ArrayHighBound(1);
			list->Clear();
			// s̐擪͍sԍ
			list->Insert(0, String(isgrow));
			for (int ii = idx0; ii <= idx1; ii++)
				list->Add(varray.GetElement(ii));
			if (StringGrid1->ColCount < list->Count)
				StringGrid1->ColCount = list->Count;
			StringGrid1->RowCount = isgrow + 1;
			StringGrid1->Rows[isgrow]->Assign(list);
		}

		// StringGridɃJo A,B,... t
		list->Clear();
		list->Add("");
		for (int i = StringGrid1->FixedCols; i < StringGrid1->ColCount; i++) {
			int icol = i - StringGrid1->FixedCols;
			String scol = (char)('A' + (icol % 26));
			int cx = icol / 26;
			while (cx > 0) {
				cx--;
				scol = String((char)('A' + (cx % 26))) + scol;
				cx = cx / 26;
			}
			list->Add(scol);
		}
		StringGrid1->Rows[0]->Assign(list);
	}
	catch (Exception &e) {
		RichEdit1->Lines->Add(e.Message);
	}

	if (vDocument.Type() == varDispatch)
		vDocument.OleProcedure("dispose");
	if (vStarDesktop.Type() == varDispatch) {
		// ̃R|[lgij terminate
		Variant venum = vStarDesktop.OleFunction("getComponents")
									.OleFunction("createEnumeration");
		if (!(bool)venum.OleFunction("hasMoreElements"))
			vStarDesktop.OleProcedure("terminate");
	}
	vDocument = Unassigned;
	vStarDesktop = Unassigned;
	vOpenOffice = Unassigned;

	delete list;

	DWORD dw9 = ::GetTickCount();
	RichEdit1->Lines->Add(String("oߎ = ") + (dw9 - dw0));
	RichEdit1->Perform(EM_SCROLL, SB_LINEDOWN, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	// Excel - NX
	StringGrid1->ColCount = 5;
	StringGrid1->RowCount = 5;
	for (int i = 0; i < 5; i++)
		StringGrid1->Rows[i]->CommaText = ",,,,";

	DWORD dw0 = ::GetTickCount();
	CPfExcel pfxl;
	if (!pfxl.Open(Edit1->Text))
		return;
	TStringList *list = new TStringList;
	int ncol = pfxl.GetColCount();
	int nrow = pfxl.GetRowCount();
	StringGrid1->ColCount = StringGrid1->FixedCols + ncol;
	StringGrid1->RowCount = StringGrid1->FixedRows + nrow;
	int irow;
	for (irow = 0; irow < nrow; irow++) {
		list->Clear();
		list->Add(irow+1); // 擪ɍsԍ
		if (!pfxl.GetRow(irow, list))
			break;
		StringGrid1->Rows[irow+1]->Assign(list);
	}
	// StringGridɃJo A,B,... t
	list->Clear();
	list->Add("");
	for (int i = StringGrid1->FixedCols; i < StringGrid1->ColCount; i++) {
		int icol = i - StringGrid1->FixedCols;
		String scol = (char)('A' + (icol % 26));
		int cx = icol / 26;
		while (cx > 0) {
			cx--;
			scol = String((char)('A' + (cx % 26))) + scol;
			cx = cx / 26;
		}
		list->Add(scol);
	}
	StringGrid1->Rows[0]->Assign(list);

	pfxl.Close();
	delete list;

	DWORD dw9 = ::GetTickCount();
	RichEdit1->Lines->Add(String("oߎ = ") + (dw9 - dw0));
	RichEdit1->Perform(EM_SCROLL, SB_LINEDOWN, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
	// Open Office Calc - NX
	StringGrid1->ColCount = 5;
	StringGrid1->RowCount = 5;
	for (int i = 0; i < 5; i++)
		StringGrid1->Rows[i]->CommaText = ",,,,";

	DWORD dw0 = ::GetTickCount();
	CPfOOCalc pfxl;
	if (!pfxl.Open(Edit1->Text))
		return;
	TStringList *list = new TStringList;
	int ncol = pfxl.GetColCount();
	int nrow = pfxl.GetRowCount();
	StringGrid1->ColCount = StringGrid1->FixedCols + ncol;
	StringGrid1->RowCount = StringGrid1->FixedRows + nrow;
	int irow;
	for (irow = 0; irow < nrow; irow++) {
		list->Clear();
		list->Add(irow+1); // 擪ɍsԍ
		if (!pfxl.GetRow(irow, list))
			break;
		StringGrid1->Rows[irow+1]->Assign(list);
	}
	// StringGridɃJo A,B,... t
	list->Clear();
	list->Add("");
	for (int i = StringGrid1->FixedCols; i < StringGrid1->ColCount; i++) {
		int icol = i - StringGrid1->FixedCols;
		String scol = (char)('A' + (icol % 26));
		int cx = icol / 26;
		while (cx > 0) {
			cx--;
			scol = String((char)('A' + (cx % 26))) + scol;
			cx = cx / 26;
		}
		list->Add(scol);
	}
	StringGrid1->Rows[0]->Assign(list);

	pfxl.Close();
	delete list;

	DWORD dw9 = ::GetTickCount();
	RichEdit1->Lines->Add(String("oߎ = ") + (dw9 - dw0));
	RichEdit1->Perform(EM_SCROLL, SB_LINEDOWN, 0);
}
//---------------------------------------------------------------------------

